unit CrLf;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles,  mPlugIn;

const
  FORM_WIDTH_SET       = 300;
  FORM_HEIGHT_SET      = 165;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  INIFILE_NAME       = 'MeryCrLf.ini';
  DLL_FOLDER_NAME    = 'Plugins';

  THIS_DEBUG         = '[s]';
  THIS_TITLE         = ' - MeryCrLf';

  VK_0 = Ord('0');
  VK_1 = Ord('1');
  VK_2 = Ord('2');
  VK_3 = Ord('3');
  VK_4 = Ord('4');
  VK_5 = Ord('5');
  VK_6 = Ord('6');
  VK_7 = Ord('7');
  VK_8 = Ord('8');
  VK_9 = Ord('9');
  VK_A = Ord('A');
  VK_B = Ord('B');
  VK_C = Ord('C');
  VK_D = Ord('D');
  VK_E = Ord('E');
  VK_F = Ord('F');
  VK_G = Ord('G');
  VK_H = Ord('H');
  VK_I = Ord('I');
  VK_J = Ord('J');
  VK_K = Ord('K');
  VK_L = Ord('L');
  VK_M = Ord('M');
  VK_N = Ord('N');
  VK_O = Ord('O');
  VK_P = Ord('P');
  VK_Q = Ord('Q');
  VK_R = Ord('R');
  VK_S = Ord('S');
  VK_T = Ord('T');
  VK_U = Ord('U');
  VK_V = Ord('V');
  VK_W = Ord('W');
  VK_X = Ord('X');
  VK_Y = Ord('Y');
  VK_Z = Ord('Z');
  VK_COMMA      = 188; // #$BC
  VK_PIRIOD     = 190; // #$BE
  VK_SLASH      = 191; // #$BF
  VK_BACKSLASH  = 226; // #$E2
  VK_SEMICOLLON = 187; // #$BB
  VK_COLLON     = 186; // #$BA
  VK_RIGHT_KAGI = 221; // #$DD ]
  VK_AT_MARK    = 192; // #$C0
  VK_LEFT_KAGI  = 219; // #&DB [
  VK_MINUS      = 189; // #$BD
  VK_HATTO      = 222; // #$DE
  VK_YEN        = 220; // #$DC

type
  TFormCrLf = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonOK: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Memo1: TMemo;
    Memo2: TMemo;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure GetCharCodeRetCode(FileName:String; Sender: TObject);
    function  GetFileName(hwnd: HWND): String;

    procedure ButtonOKClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;
    StrIniFileName: String;
    StrLoadFileName: String;
    IntHwnd: Thandle;
  public
    { Public 錾 }
  end;

var
  FormCrLf: TFormCrLf;

implementation

{$R *.dfm}

procedure TFormCrLf.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormCrLf.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormCrLf', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormCrLf', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormCrLf', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormCrLf', 'Left',   FormCrLf.Left);
    IniFile.WriteInteger('FormCrLf', 'Top',    FormCrLf.Top);
    IniFile.WriteInteger('FormCrLf', 'Width',  FormCrLf.Width);
    IniFile.WriteInteger('FormCrLf', 'Height', FormCrLf.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormCrLf.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormCrLf.FormCreate(Sender: TObject);
begin
;
end;

procedure TFormCrLf.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormCrLf.FormResize(Sender: TObject);
begin
  Panel2.Width := FormCrLf.ClientWidth div 2;
end;

procedure TFormCrLf.FormShow(Sender: TObject);
var
  sStr3: String;
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormCrLf.KeyPreview := TRUE;

  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //
  IntFormShiftX  := 0;
  IntFormShiftY  := 0;

  //
  Panel4.Caption := 'Cr:';
  Panel5.Caption := 'Lf:';
  Memo1.Lines.Clear;
  Memo2.Lines.Clear;
  FormCrLf.Caption := THIS_TITLE;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormCrLf', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormCrLf', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormCrLf', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormCrLf', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormCrLf', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //Ǎ
  IntHwnd := StrToInt(IniFile.ReadString ('Editor',     'HWND',    ''));
  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormCrLf.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormCrLf.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormCrLf.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormCrLf.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //Jg̃t@C擾
  sStr3 := GetFileName(Inthwnd);
  FormCrLf.Caption := ExtractFileName(sStr3) + THIS_TITLE;
  //
  if sStr3 = '' then
  begin
    showmessage('t@Cł');
  end
  else
  begin
    //ݒ
    StrLoadFileName := sStr3;
    //擾
    GetCharCodeRetCode(StrLoadFileName, Sender);
  end;
end;


procedure TFormCrLf.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //OK
    ButtonOKClick(Sender);
  end
  else
  begin
    //
  end;
end;

procedure TFormCrLf.GetCharCodeRetCode(FileName:String; Sender: TObject);
var
  i: Integer;
  hFindData1: THandle;
  pBuff1: PAnsiChar;
  File1: TSearchRec;
  FileStream1 :TFileStream;
  StrListCr: TStringList;
  StrListLf: TStringList;
begin
  //m
  StrListCr := TStringList.Create;
  StrListLf := TStringList.Create;

  //NA
  StrListCr.Clear;
  StrListLf.Clear;

  //t@CTCY擾
  hFindData1 := System.SysUtils.FindFirst(Filename, faAnyFile, File1);
  try
    ;
  finally
    System.SysUtils.FindClose(File1);
  end;

  //s
  if hFindData1 <> 0 then
  begin
    ShowMessage('t@C܂');
  end
  else
  begin
    //TCY
    if File1.Size = 0 then
    begin
      ShowMessage('t@CTCY 0 ł');
    end
    //eL
    else
    begin
      //TCYw肵ăm
      pBuff1 := AllocMem(File1.Size);
      try
        //̓t@Cݒ肵ēǂݍ
        FileStream1 := TFileStream.Create(StrLoadFileName, fmOpenRead);
        try
          FileStream1.Read(pBuff1^, File1.Size);
        finally
          FileStream1.Free;
        end;

        for i := 0 to (File1.Size-1) do
        begin
          // CR
          if      ( (pBuff1[i+0] = #13) ) then
          begin
            StrListCr.Add(Format('%.09d', [i]));
          end
          // LF
          else if ( (pBuff1[i+0] = #10) ) then
          begin
            StrListLf.Add(Format('%.09d', [i]));
          end
          //
          else
          begin
          end;
        end;
      finally
        FreeMem(pBuff1);
      end;
    end;
  end;

  //\
  Panel4.Caption := 'Cr:' + IntToStr(StrListCr.Count);
  Panel5.Caption := 'Lf:' + IntToStr(StrListLf.Count);
  //\
  Memo1.Lines.BeginUpdate;
  Memo1.Lines.Assign(StrListCr);
  Memo1.SelStart := 0;
  Memo1.Lines.EndUpdate;
  //\
  Memo2.Lines.BeginUpdate;
  Memo2.Lines.Assign(StrListLf);
  Memo2.SelStart := 0;
  Memo2.Lines.EndUpdate;

  //sv
  if StrListCr.Count <> StrListLf.Count then
  begin
    Panel4.Color := clRed;
    Panel5.Color := clRed;
  end;

  //j
  StrListCr.Free;
  StrListLf.Free;
end;

procedure TFormCrLf.ButtonOKClick(Sender: TObject);
begin
  //I
  Close;
end;

//t@C̎擾
function TFormCrLf.GetFileName(hwnd: HWND): String;
var
  szName: array [0..1023] of Char;
begin
// -----------------------------------------------------------------------------
// Editor_Info
//   ̏擾Eݒ肵܂
// p[^
//   hwnd: EBhẼnh
//   nCmd: 擾Eݒ肷̎
// ߂l
//   nCmdɂقȂ܂
// l
//   MI_GET_FILE_NAME:      JĂt@C擾܂
// -----------------------------------------------------------------------------

  //Jg̃t@C擾
  Editor_Info(hwnd, MI_GET_FILE_NAME, LPARAM(@szName));
  Result := StrPas(szName);
end;

end.
